examples.jmarkov

## Class HiperExQueue

- java.lang.Object
- - jmarkov.MarkovProcess<S,E>
  - - jmarkov.SimpleMarkovProcess<GeomState<Sub>,E>
    - - jmarkov.GeomProcess<examples.jmarkov.HiperExQueueState,examples.jmarkov.HiperExQueueEvent>
      - - examples.jmarkov.HiperExQueue

- All Implemented Interfaces:
    JMarkovElement

      public class HiperExQueue
      extends GeomProcess<examples.jmarkov.HiperExQueueState,examples.jmarkov.HiperExQueueEvent>

  This class implements a system with one server with PH service. The server has an infinite capacity.
  Author:
    Julio C. Goez - Germán Riaño. Universidad de los Andes.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class jmarkov.MarkovProcess

      `MarkovProcess.Status`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `HiperExQueue()` Used by GUI.
    `HiperExQueue(double lambda, PhaseVar dists)` This class model a series of stations with poisson arrival rate, and Phase type service distributions.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `active(examples.jmarkov.HiperExQueueState i, int iLevel, examples.jmarkov.HiperExQueueEvent e)` The user must extend this method to determine which events are active.
    `java.lang.String` | `description()` This method should be implemented by the subclass to give word description of the model.
    `GeomRelState<examples.jmarkov.HiperExQueueState>[]` | `dests(examples.jmarkov.HiperExQueueState i, int absLevel, examples.jmarkov.HiperExQueueEvent e)` Determines the destination set of States when events e occurs.
    `static void` | `main(java.lang.String[] a)` Main method
    `double` | `rate(examples.jmarkov.HiperExQueueState i, int iLevel, examples.jmarkov.HiperExQueueState j, int jLevel, examples.jmarkov.HiperExQueueEvent e)` This method calculates the rate of transition from i to j when occurs the event e.

    - ### Methods inherited from class jmarkov.GeomProcess

      `active, dests, getAMatrices, getBMatrices, getBoundaryStates, getEventRate, getExpectedLevel, getGeometrixSolver, getInitialSol, getMOPsMoment, getNumBoundaryStates, getNumTypicalStates, getRmatrix, getStateClass, getStates, getSteadyState, getSubMatrices, getTypicalStates, getVectorPi0, getVectorPi1, getVectorPi1Mod, isStable, matrixRtoArray, printAll, printStates, rate, reset, setGeometrixSolver, steadyProbabilities`

    - ### Methods inherited from class jmarkov.SimpleMarkovProcess

      `activeTransitions`

    - ### Methods inherited from class jmarkov.MarkovProcess

      `addMOP, allToString, canGo, clearMOPs, debug, debug, debug, denseMatrixToString, denseMatrixToString, eventRatesToString, eventsRatesToString, generate, getDebugLevel, getDebugReporter, getEventClass, getEventNames, getEvents, getEventsRates, getFinalRate, getGenerator, getMaxStates, getMOPIndex, getMOPNames, getMOPNames, getMOPsAvg, getMOPsAvg, getMOPsAvg, getMOPsMoment, getMOPsMoment, getMtjGenerator, getMtjRates, getNumStates, getProgress, getRate, getRates, getRates, getStates, getStatus, getStatusMsg, getSteadyState, getSteadyStateSolver, getTransientSolver, go, goStep, hideGUI, isGenerated, killGUI, label, loadGUI, MOPsToString, MOPsToString, numMOPs, pause, printAll, printDenseMatrix, printDenseMatrix, printEventsRates, printEventsRates, printMOPs, printMOPs, printMOPs, printStates, resetResults, setDebugLevel, setDebugReporter, setMaxStates, setMOPs, setSteadyStateSolver, setTransientSolver, showGUI, statesLableMaxWidth, statesToString, toString`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface jmarkov.basic.JMarkovElement

      `equals`

- - ### Constructor Detail

    - #### HiperExQueue

          public HiperExQueue(double lambda,
                      PhaseVar dists)

      This class model a series of stations with poisson arrival rate, and Phase type service distributions. There is a limited buffer capacity between stations
      Parameters:
        `lambda` - Arrival rate
        `dists` - service distributions

    - #### HiperExQueue

          public HiperExQueue()

      Used by GUI.

  - ### Method Detail

    - #### active

          public boolean active(examples.jmarkov.HiperExQueueState i,
                       int iLevel,
                       examples.jmarkov.HiperExQueueEvent e)

      Description copied from class: `GeomProcess`
      The user must extend this method to determine which events are active.
      Specified by:
        `active` in class `GeomProcess<examples.jmarkov.HiperExQueueState,examples.jmarkov.HiperExQueueEvent>`
      Parameters:
        `i` - the current sub state
        `iLevel` - Absolute level of current State i. You should test only whether it is 0 (boundary), 1 or greater than 1. Your code should not behave any different if the level is 2, or 3, etc
        `e` - The event being tested.
      Returns:
        tru if this event occurs

    - #### dests

          public GeomRelState<examples.jmarkov.HiperExQueueState>[] dests(examples.jmarkov.HiperExQueueState i,
                                                                 int absLevel,
                                                                 examples.jmarkov.HiperExQueueEvent e)

      Description copied from class: `GeomProcess`
      Determines the destination set of States when events e occurs. It has to be implemented by the subclass.
      Specified by:
        `dests` in class `GeomProcess<examples.jmarkov.HiperExQueueState,examples.jmarkov.HiperExQueueEvent>`
      Parameters:
        `i` - current State.
        `absLevel` - absolute level of current State. For QBD this is 0, 1 or 2. Anything above 2 should report the same result.
        `e` - The Event that ocurred.
      Returns:
        The destination States

    - #### rate

          public double rate(examples.jmarkov.HiperExQueueState i,
                    int iLevel,
                    examples.jmarkov.HiperExQueueState j,
                    int jLevel,
                    examples.jmarkov.HiperExQueueEvent e)

      This method calculates the rate of transition from i to j when occurs the event e.
      Specified by:
        `rate` in class `GeomProcess<examples.jmarkov.HiperExQueueState,examples.jmarkov.HiperExQueueEvent>`
      Parameters:
        `i` - initial state.
        `j` - final state.
        `e` - event.
        `iLevel` - current state's absolute level
        `jLevel` - destination level
      Returns:
        the rate of a transition from i to j when ocurr

    - #### description

          public java.lang.String description()

      Description copied from class: `MarkovProcess`
      This method should be implemented by the subclass to give word description of the model. For example it should say: Queueing system with 2 servers and exponential arrivals with rate 50 per hour.
      Specified by:
        `description` in interface `JMarkovElement`
      Specified by:
        `description` in class `MarkovProcess<GeomState<examples.jmarkov.HiperExQueueState>,examples.jmarkov.HiperExQueueEvent>`
      Returns:
        A description of the Model
      See Also:
        `JMarkovElement.label()`

    - #### main

          public static void main(java.lang.String[] a)

      Main method
      Parameters:
        `a` - Not used